package domaine.temps;

import java.util.StringTokenizer;

import domaine.Operation;

public class HeureV1 implements Heure {
	private int h, m;
	public HeureV1() {
		h = 12;
		m = 0;
	}
	public void affecteA(int heures, int minutes)
	throws MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
		if (heures >= 0 && heures < 24)
			h = heures;
		else
			throw new MauvaiseValeurDesHeures(heures);
		if (minutes >= 0 && minutes < 60)
			m = minutes;
		else
			throw new MauvaiseValeurDesMinutes(minutes);
	}
	public HeureV1(int heures, int minutes) 
	throws MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
		affecteA(heures, minutes);
	}
	public void affecteA(String heure) throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
		if (Heure.texteCorrect(heure)) {
			StringTokenizer st = new StringTokenizer(heure, ":");
			int heures, minutes;
			heures = Integer.parseInt(st.nextToken()); //inutile d'attraper NumberFormatException
			minutes = Integer.parseInt(st.nextToken());
			affecteA(heures, minutes);
		} else {
			throw new MauvaisFormatDHeure(heure);
		}
	}
	public HeureV1(String texte) throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes{
		affecteA(texte);
	}
	public byte heures() {
		return (byte)h;
	}
	public byte minutes() {
		return (byte)m;
	}
	public void minutesPlus1() {
		m++;
		if (m == 60) {
			m = 0;
			heuresPlus1();
		}
	}
	public void minutesMoins1() {
		m--;
		if (m == -1) {
			m = 59;
			heuresMoins1();
		}
	}
	public void heuresPlus1() {
		h++;
		if (h == 24)
			h = 0;
	}
	public void heuresMoins1() {
		h--;
		if (h < 0)
			h = 23;
	}
	public String toString() {
		return String.format("%02d:%02d", h, m);
	}
	public int compareTo(Heure autre) {
		if (h > autre.heures()) return 1;
		if (h == autre.heures()) { //return m - autre.minutes();
			if (m > autre.minutes()) return 1;
			if (m == autre.minutes()) return 0;
			return -1;
		}
		return -1;
	}
    public void realise(Operation op) throws Exception {
    	op.opereSur(this);
    }
}
