package domaine;

import static org.junit.jupiter.api.Assertions.*;

import java.util.Iterator;

import org.junit.jupiter.api.Test;

import domaine.temps.MauvaisFormatDHeure;
import domaine.temps.MauvaiseValeurDesHeures;
import domaine.temps.MauvaiseValeurDesMinutes;

class TestListeDAlarmes {
    @Test
    public void test01Constructeur() {
        ListeDAlarmes lst;
        lst = new ListeDAlarmes();
        assertTrue(lst.estVide());
        assertEquals(0, lst.nombreDElements());
    }
    @Test
    public void test02Ajout() throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        ListeDAlarmes lst;
        lst = new ListeDAlarmes();
        lst.ajoute(new Alarme("12:00"));
        lst.ajoute(new Alarme("10:30"));
        lst.ajoute(new Alarme("16:15"));
        lst.ajoute(new Alarme(10, 30));
        assertEquals(4, lst.nombreDElements());
        Alarme a1;
		Alarme a2;
        Iterator<Alarme> it = lst.iterator();
        boolean enOrdreCroissant = true;
        a1 = it.next();
        while(it.hasNext()) {
            a2 = it.next();
            if (a1.compareTo(a2) > 0) enOrdreCroissant = false;
            a1 = a2;
        }
        assertTrue(enOrdreCroissant);
    }
    @Test
    public void test03EnregistrementEtChargementTexte() throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        ListeDAlarmes lst;
        lst = new ListeDAlarmes();
        lst.ajoute(new Alarme(8, 0));
        lst.ajoute(new Alarme(9, 0));
        lst.ajoute(new Alarme(12, 30));
        lst.ajoute(new Alarme(13, 30));
        lst.ajoute(new Alarme(17, 0));
        lst.ajoute(new Alarme(20, 0));
        assertEquals(ResultatEnregistrementChargement.REUSSI, lst.enregistreSous("test.txt"));
        ListeDAlarmes lue = new ListeDAlarmes();
        assertEquals(ResultatEnregistrementChargement.REUSSI, lue.charge("test.txt"));
        assertEquals(lue.nombreDElements(), lst.nombreDElements());
        Iterator<Alarme> itlst = lst.iterator();
        Iterator<Alarme> itlue = lue.iterator();
        while(itlst.hasNext()) {
            assertEquals(0, itlst.next().compareTo(itlue.next()));
        }
    }

}
